# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1


class DealCombinedMetricsResponse(pydantic_v1.BaseModel):
    date: str = pydantic_v1.Field()
    """
    Date of the revenue metric.
    """

    method: str = pydantic_v1.Field()
    """
    Method used to calculate the revenue metric. When 'product' then the revenue is from the product data, when 'financials' then the revenue is from the financials data.
    """

    revenue: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Revenue
    """

    rolling_3_m_average_revenue: typing.Optional[float] = pydantic_v1.Field(
        alias="rolling_3m_average_revenue", default=None
    )
    """
    Average Revenue (Rolling Q)
    """

    annualized_revenue: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Annualized Revenue
    """

    rolling_3_m_annualized_revenue: typing.Optional[float] = pydantic_v1.Field(
        alias="rolling_3m_annualized_revenue", default=None
    )
    """
    Annualized Revenue (Rolling Q)
    """

    revenue_share_of_top_20_percent: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Revenue Share of Top 20%
    """

    revenue_share_of_top_10_count: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Revenue Share of Top 10 Users
    """

    average_to_median: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Average to Median Revenue
    """

    gini_coefficient: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Gini Coefficient
    """

    lifetime_quick_ratio: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Average Quick Ratio
    """

    lifetime_gross_retention: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Average Gross Retention
    """

    lifetime_net_churn: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Average Net Churn
    """

    cmgr_3: typing.Optional[float] = pydantic_v1.Field(alias="cmgr3", default=None)
    """
    CMGR3
    """

    cmgr_6: typing.Optional[float] = pydantic_v1.Field(alias="cmgr6", default=None)
    """
    CMGR6
    """

    cmgr_12: typing.Optional[float] = pydantic_v1.Field(alias="cmgr12", default=None)
    """
    CMGR12
    """

    yoy: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    YoY Growth
    """

    operating_margin: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Operating Margin
    """

    quarterly_operating_margin: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Operating Margin (Rolling Q)
    """

    gross_margin: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Gross Margin
    """

    quarterly_gross_margin: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Gross Margin (Rolling Q)
    """

    magic_number: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Magic Number
    """

    rule_of_40: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Rule of 40
    """

    burn_multiple: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Burn Multiple
    """

    acquisition_spend: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Acquisition Spend
    """

    total_opex: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Total OPEX
    """

    logo_retention_6_m: typing.Optional[float] = pydantic_v1.Field(alias="logo_retention_6m", default=None)
    """
    Logo Retention (6M)
    """

    logo_retention_12_m: typing.Optional[float] = pydantic_v1.Field(alias="logo_retention_12m", default=None)
    """
    Logo Retention (12M)
    """

    revenue_retention_6_m: typing.Optional[float] = pydantic_v1.Field(alias="revenue_retention_6m", default=None)
    """
    Revenue Retention (6M)
    """

    revenue_retention_12_m: typing.Optional[float] = pydantic_v1.Field(alias="revenue_retention_12m", default=None)
    """
    Revenue Retention (12M)
    """

    ltv_6_m: typing.Optional[float] = pydantic_v1.Field(alias="ltv_6m", default=None)
    """
    LTV6
    """

    ltv_12_m: typing.Optional[float] = pydantic_v1.Field(alias="ltv_12m", default=None)
    """
    LTV12
    """

    ltv_6_cac: typing.Optional[float] = pydantic_v1.Field(alias="ltv6_cac", default=None)
    """
    LTV6/CAC
    """

    ltv_12_cac: typing.Optional[float] = pydantic_v1.Field(alias="ltv12_cac", default=None)
    """
    LTV12/CAC
    """

    gmltv_6_cac: typing.Optional[float] = pydantic_v1.Field(alias="gmltv6_cac", default=None)
    """
    gmLTV6/CAC
    """

    gmltv_12_cac: typing.Optional[float] = pydantic_v1.Field(alias="gmltv12_cac", default=None)
    """
    gmLTV12/CAC
    """

    lifetime_ltv_6_cac: typing.Optional[float] = pydantic_v1.Field(alias="lifetime_ltv6_cac", default=None)
    """
    Average LTV6/CAC
    """

    lifetime_ltv_12_cac: typing.Optional[float] = pydantic_v1.Field(alias="lifetime_ltv12_cac", default=None)
    """
    Average LTV12/CAC
    """

    lifetime_gmltv_6_cac: typing.Optional[float] = pydantic_v1.Field(alias="lifetime_gmltv6_cac", default=None)
    """
    Average gmLTV6/CAC
    """

    lifetime_gmltv_12_cac: typing.Optional[float] = pydantic_v1.Field(alias="lifetime_gmltv12_cac", default=None)
    """
    Average gmLTV12/CAC
    """

    cac: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    CAC
    """

    irr: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    IRR
    """

    periods_to_payback: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Months to Payback
    """

    employee_count: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Number of Employees
    """

    cumulative_person_years: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Cumulative Years of Effort
    """

    employee_retention_1_yr: typing.Optional[float] = pydantic_v1.Field(alias="employee_retention_1yr", default=None)
    """
    Employee Retention (1Y)
    """

    employee_retention_2_yr: typing.Optional[float] = pydantic_v1.Field(alias="employee_retention_2yr", default=None)
    """
    Employee Retention (2Y)
    """

    average_years_of_experience: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Average Employee Experience (Years)
    """

    lifetime_employee_retention: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Lifetime Employee Retention
    """

    percent_employees_sales_and_marketing: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Sales + Marketing (% Employees)
    """

    fully_loaded_employee_cost: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Fully-Loaded Employee Cost
    """

    annualized_revenue_per_employee: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    Annualized Revenue per Employee
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
