# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1


class WeatherMarketContext(pydantic_v1.BaseModel):
    stage: str = pydantic_v1.Field()
    """
    The stage of the weather gauge
    """

    date: str = pydantic_v1.Field()
    """
    The date of the data point
    """

    total_amount_raised_annualized: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    A simple estimate of total amount of fundraising in the market at the stage in a rolling window
    """

    rounds_annualized: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    A simple estimate of total count of rounds in the market at the stage in a rolling window
    """

    average_raise_years: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    The average number of years between raises in the market at the stage in a rolling window
    """

    average_amount_raised: typing.Optional[float] = pydantic_v1.Field(default=None)
    """
    The average amount raised in the market at the stage in a rolling window
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
